image: node:latest

variables:
  IMAGE_NAME: ehvi/produit
  IMAGE_TAG: app
  DOCKER_REGISTRY_USER: ehvi
  DOCKER_REGISTRY_PASS: dckr_pat_BgHXDeGhOKNVy73g7huzRDp6MXc
  CACHE_PATH: node_modules/

stages:
  - build
  - scan
  - publish
  - test

include:
  - template: Security/Dependency-Scanning.gitlab-ci.yml

produit-build:
  stage: build
  before_script:
    - cd backend/produit
  script:
    - npm install
  artifacts:
    paths:
      - node_modules
  cache:
    key: ${CACHE_PATH}-${CI_COMMIT_REF_SLUG}
    paths:
      - ${CACHE_PATH}

produit-scan:
  stage: scan
  before_script:
    - cd bakend/produit
  script:
    - npm install
    - npm audit

produit-publish:
  stage: publish
  image: docker:20.10.16
  services:
    - docker:20.10.16-dind
  variables:
    DOCKER_TLS_CERTDIR: "/certs"
  before_script:
    - cd backend/produit
    - docker login -u $DOCKER_REGISTRY_USER -p $DOCKER_REGISTRY_PASS

  script:
    - docker build -t $IMAGE_NAME:$IMAGE_TAG .
    - docker push $IMAGE_NAME:$IMAGE_TAG
